<?php
class qc_private {

	var $version = 102;
	
	function __construct()
	{
		// Add administration actions
		add_action('init', array(&$this, 'initialise_plugin'), 1);
		add_action('admin_menu', array(&$this, 'add_admin_menu'));
	}
	
	function initialise_plugin()
	{
		global $user, $setting;

		$installed = get_option('QC_CHAT_INSTALLED', false);

		if(empty($user)) {
			$user = wp_get_current_user();
		}
	
		if($installed === false || $installed != $this->version)
		{
			include_once(PLUG_ROOT.'qc_install.php');
			QC_Upgrade($installed);
			update_option('QC_CHAT_INSTALLED', $this->version);
		}
		
		$setting = @mysql_fetch_assoc(mysql_query("SELECT * FROM `qchat_settings` LIMIT 1"));

		// Styles / Scripts
		wp_enqueue_style('qc_inline_css', PLUG_URL.'qc_bin/private.css');
    wp_enqueue_script('private', PLUG_URL.'qc_bin/private.js');
		wp_enqueue_script('tools', PLUG_URL.'qc_bin/tools.js');
		wp_enqueue_script('qc', PLUG_URL.'qc_bin/qc.js');
	}

	function add_admin_menu()
	{
		global $menu, $admin_page_hooks;

		add_menu_page( "Quack Chat", "Quack Chat", "edit_posts", 'qchat', array(&$this,'qchat_homepage'), PLUG_URL."/qc_images/qc_icon.png");
		
		add_submenu_page( "qchat", "Online", "Online", 'edit_posts', 'qonline', array(&$this,'qchat_online') ); 
		
		add_submenu_page( "qchat", "History", "History", 'edit_posts', 'qhistory', array(&$this,'qchat_history') ); 
		
		add_submenu_page( "qchat", "Settings", "Settings", 'edit_posts', 'qsettings', array(&$this,'qchat_settings') ); 

	}
	

	function qchat_footer()
	{
		return '
    </div>
    </center>
    <div style="clear: both;"></div>';
	}
	
	function qchat_header()
	{
		global $setting;
		$ios = false;
		$p = $_GET['page'];
		if (preg_match("/(?:ipod|ipad|iphone)/i", $_SERVER['HTTP_USER_AGENT'])){  $ios = true; 
		?>
    <meta name="viewport" content="width=600, initial-scale=0.53, user-scalable=no"/>
    <meta name="apple-mobile-web-app-capable" content="yes" />
    <meta name="apple-mobile-web-app-status-bar-style" content="black" />
    <link rel="apple-touch-icon" href="<?php echo PLUG_URL; ?>qc_images/ios/icon.png"/>
    <?php } elseif (preg_match("/webOS/", $_SERVER['HTTP_USER_AGENT'])){?>
    <meta name="viewport" content="width=600, initial-scale=0.4, user-scalable=no"/>
    <?php } else { ?>
    <meta name="viewport" content="width=600, initial-scale=0.4, user-scalable=yes"/>
    <?php } ?>
    <meta name="HandheldFriendly" content="true"/>
    <meta name="MobileOptimized" content="600"/>
    <script language="javascript" type="text/javascript">
    var qc = qc_chat;
    window.onload = function()
    {
      qc.base_url = "<?php echo PLUG_URL; ?>";
      qc.setup('<?php echo $p; ?>');
    }
    </script>
    <center>
    <div align="center" style="width:600px;">
    <div id="qc_cover" style="position: fixed; top: 0px; left: 0px; z-index: 10000;display:none;background-image:url('<?php echo PLUG_URL; ?>qc_images/trans.png');width:100%;height:1000px;" onclick="this.style.display='none'"></div>
    <table width="100%" border="0" cellspacing="0" cellpadding="10">
      <tr>
        <td align="left" valign="bottom"><img src="<?php echo PLUG_URL; ?>qc_images/qc_logo.png" width="193" height="29" /></td>
        <?php if ($p == "qonline" && $ios){ ?>
        <td align="right" valign="bottom"><img src="<?php echo PLUG_URL; ?>qc_images/sound_add.png" width="32" height="32" onclick="document.getElementById('ios_sound_bite').style.display=((document.getElementById('ios_sound_bite').style.display=='none')?'block':'none');" />
          <div id="ios_sound_bite">
            <h3>No sound?!<br />
              You need to enable it...</h3>
            <p>Apple, by default disables the auto-play back of any audio/video on a website using IOS. </p>
            <p>To enable this you must physically click the play button below each time you visit this page. </p>
            <div id="ios_sound_enabled" style="display: none; text-align:center; font-weight: bold;">Sound has been enabled!</div>
            <audio controls="controls" onplaying="qc.ios_enabled();">
              <source src="<?php echo PLUG_URL; ?>qc_bin/sounds/scifi014.mp3" />
            </audio>
            <br />
            <br />
            [ <a href="javascript:void(0)" onclick="document.getElementById('ios_sound_bite').style.display='none';">Close Window</a> ] </div></td>
        <?php } ?>
        <td align="right" valign="bottom"><img src="<?php echo PLUG_URL; ?>qc_images/broadcast_on.gif" width="32" height="32" /></td>
      </tr>
    </table>
    <?php
	}
	
	function qchat_online()
	{
		global $setting;
		echo $this->qchat_header();
		?>
		<table align="center" width="95%" border="0" cellpadding="0" cellspacing="0"><tr><td align="left"><a href="admin.php?page=qchat" onclick="cover_me()"><img src="<?php echo PLUG_URL; ?>qc_images/btn_back.png" border="0"></a></td>
    <td align="right"><h2>Current Chat Sessions</h2></td></tr></table>
    <div id="chat_sessions" style="color:#FFFFFF;"><b>loading...</b></div>
    <br/>
    <hr style="border:1px dotted #aeaeae;">
    <div id="current_ph" style="background-color:#152b4d;color:#aeaeae;width:98%;height:300px;overflow:hidden;font-size:24px;padding:4px;"> <br/>
      <br/>
      <br/>
      <br/>
      <center>
        Select someone from the list above.<br/>
        <br/>
        Their chat session will appear here.
      </center>
    </div>
    <div id="current_chat" style="width:100%;display:none;">
      <div id="chat_window" style="background-image:url('<?php echo PLUG_URL; ?>qc_images/trans.png');color:#51ec60;border:1px solid #51ec60;width:98%;height:300px;overflow:hidden;font-size:19px;text-align:left;padding:4px;"> <br/>
        <br/>
        <br/>
        <br/>
        <center>
          You are being routed.. and switched.. and stuff..
        </center>
      </div>
      <hr style="border:1px dotted #aeaeae;">
      <div id="message_window" style="display:none;width:99%;height:80px;">
        <table width="100%" border="0" cellpadding="0" cellspacing="1" style="height:100%;">
          <tr>
            <td width="75%" height="100%"><textarea id="chat_message" onkeypress="qc.ifEnter(this, event);" style="background-color:transparent;background-image:url('<?php echo PLUG_URL; ?>qc_images/trans.png');border:1px solid #152b4d;width:100%;height:84px;font-size:22px;font-weight:bold;color:#ffffff;"></textarea></td>
            <td align="right" width="25%" height="100%"><div style="padding:2px;">
                <input type="button" value="SEND" style="width:96%;height:90px;font-size:22px;font-weight:bold;" onClick="qc.send_message();" />
              </div>
            </td>
          </tr>
        </table>
      </div>
      <div id="message_holder" style="background-image:url('<?php echo PLUG_URL; ?>qc_images/trans.png');font-size:18px;color:#51ec60;text-align:center;width:99%;height:80px;border:1px dotted #ffffff;"> <br/>
        <br/>
        Please wait.. we are connecting you. </div>
      <br/>
      <br/>
      <br/>
      <br/>
    </div>
    <div id="sound_bite"></div>
    <?php
		echo $this->qchat_footer();
	}
	
	function qchat_history()
	{
		global $setting;
		$page = $ended = false;
		$page_no = $act = $id = NULL;
		
		if (isset($_GET['page_no'])){ $page_no = $_GET['page_no']; }
		if (isset($_GET['act'])){ $act = $_GET['act']; }
		if (isset($_GET['id'])){ $id = $_GET['id']; }

		if ($act == "delete" && $id)
		{
			mysql_query("DELETE FROM `qchat_messages` WHERE `session`='".$id."'");
			mysql_query("DELETE FROM `qchat_sessions` WHERE `id`='".$id."'");
		}
		elseif ($act == "deleteall")
		{
			mysql_query("TRUNCATE TABLE `qchat_messages`");
			mysql_query("TRUNCATE TABLE `qchat_sessions`");
		}
		
		echo $this->qchat_header();

		if ($id)
		{
			$id_previous = @mysql_result(mysql_query("SELECT `id` FROM `qchat_sessions` WHERE `id`<".$id." ORDER BY `id` DESC LIMIT 1"), 0);
			$id_next = @mysql_result(mysql_query("SELECT `id` FROM `qchat_sessions` WHERE `id`>".$id." ORDER BY `id` ASC LIMIT 1"), 0);
			$num_of[0] = mysql_num_rows(mysql_query("SELECT `id` FROM `qchat_sessions` WHERE `id`<=".$id.""));
			$num_of[1] = mysql_num_rows(mysql_query("SELECT * FROM `qchat_sessions`"));
			$page_back = ceil(($num_of[1] - $num_of[0]) / 10);
			echo '<table align="center" width="95%" border="0" cellpadding="0" cellspacing="0"><tr><td align="left"><a href="admin.php?page=qhistory&page_no='.$page_back.'" onclick="cover_me()">'
			. '<img src="'.PLUG_URL.'qc_images/btn_back.png" border="0"></a></td><td align="right"><h2>Message History</h2></td></tr></table>';
			
			$q = mysql_query("SELECT * FROM `qchat_sessions` WHERE `id`='".$id."' LIMIT 1") or die (mysql_error());
			while ($c = mysql_fetch_assoc($q))
			{
				$mq = mysql_query("SELECT * FROM `qchat_messages` WHERE `session`='".$c['id']."' ORDER BY `id` ASC");
				$messages = mysql_num_rows($mq);
				echo '<div style="background-image:url('.PLUG_URL.'qc_images/trans.png);border:1px solid #dedede;cursor:pointer;font-weight:bold;" '
				. 'onmouseover="this.style.backgroundColor=\'#deeade\'" onmouseout="this.style.backgroundColor=\'\'" onclick="delete_session('.$c['id'].', \''.$c['name'].'\', '.$messages.');">
					<div style="display:inline-block;text-align:left;height:30px;width:395px;">'.truncate($c['name'], 25).' <span class="orange">('.$messages.')</span></div>
					<!-- <div style="display:inline-block;text-align:left;height:30px;width:100px;">'.$messages.' messages</div> -->
					<!-- <div style="display:inline-block;text-align:left;height:30px;width:200px;text-align:center;">'.date("F j, Y", $c['date']).'</div> -->
					<div style="display:inline-block;text-align:left;height:30px;width:150px;">'.timetostr(time() - $c['date']).'</div>
					<div style="display:inline-block;text-align:left;height:30px;width:25px;font-size:32px;" onmouseover="this.style.color=\'#ea0000\'" onmouseout="this.style.color=\'#ffffff\'"><b>x</b></div>
				</div>
				<div style="display:block;height:5px;"></div>
				
				<hr style="border:1px dotted #aeaeae;"/>';
				while ($m = mysql_fetch_assoc($mq))
				{
					$color = 'transparent';
					$font_color = '#ffffff;background-image:url('.PLUG_URL.'qc_images/trans.png)';
					$name = $c['name'].": ";
					$message = $m['message'];
		
					
					if (!$m['sender'])
					{
						$color = 'transparent';
						$font_color = '#fdc500';
						$name = "Admin: ";
					}
					
					if ($m['date'] > $c['update'])
					{
						$ended = true;
						echo '<div style="background-color:#8c8d9e;border:1px solid #ff4545;color:#000000;padding:4px;">
						<div style="display:inline-block;text-align:left;height:30px;width:475px;"><b>'.$c['name'].' ended the chat session.</b></div>
						<div style="display:inline-block;text-align:left;height:30px;">'.date("g:i:s a", $c['update']).'</div>
						</div>
						<div style="height:3px;"></div>';
					}
					
					echo '<div style="background-color:'.$color.';color:'.$font_color.';font-size:22px;padding:4px;">
						<div style="display:inline-block;text-align:left;overflow:hidden;height:20px;width:100px;font-size:14px;"><b>'.$name.'</b></div>
						<div style="display:inline-block;text-align:left;width:395px;">'.stripslashes($message).'</div>
						<div style="display:inline-block;text-align:left;height:20px;font-size:14px;">'.date("g:i:s a", $m['date']).'</div>
					</div>
					<div style="height:3px;"></div>';
				}
				
				if (!$ended)
				{
					echo '<div style="background-color:#8c8d9e;border:1px solid #ff4545;color:#000000;padding:4px;">
						<div style="display:inline-block;overflow:hidden;height:30px;width:475px;"><b>'.$c['name'].' ended the chat session.</b></div>
						<div style="display:inline-block;overflow:hidden;height:30px;">'.date("g:i:s a", $c['update']).'</div>
					</div>';
				}
				
				echo '<div style="display:block;height:5px;"></div>
				<div style="display:inline-block;width:150px;">';
				if ($id_previous) echo '<a href="admin.php?page=qhistory&id='.$id_previous.'" onclick="cover_me()"><img src="'.PLUG_URL.'qc_images/btn_previous.png" border="0" /></a>';
				echo '</div><div style="display:inline-block;width:250px;">'.$num_of[0].' of '.$num_of[1].'</div><div style="display:inline-block;width:150px;">';
				if ($id_next) echo '<a href="admin.php?page=qhistory&id='.$id_next.'" onclick="cover_me()"><img src="'.PLUG_URL.'qc_images/btn_next.png" border="0" /></a>';
				echo '</div><br/>';
			}
		}
		else
		{
			echo '<table align="center" width="95%" border="0" cellpadding="0" cellspacing="0"><tr><td align="left"><a href="admin.php?page=qchat" onclick="cover_me()">'
			. '<img src="'.PLUG_URL.'qc_images/btn_back.png" border="0"></a></td>
			<td align="right"><h2>Chat history</h2></td></tr></table>';
			$i=0;
			// PAGING STUFF =====--------------
			if (!$page) $page = 1;
			$offset = ($page-1)*10;
			
			echo '<div id="historyContainer">'; // OPEN AJAX DIV - Forget AJAX DIV, not enough time.
			$q = mysql_query("SELECT * FROM `qchat_sessions` ORDER BY `id` DESC LIMIT ".$offset.",10") or die (mysql_error());
			while ($c = mysql_fetch_assoc($q))
			{
				$i++;
				$messages = mysql_num_rows(mysql_query("SELECT * FROM `qchat_messages` WHERE `session`='".$c['id']."'"));
				echo '<div style="background-image:url('.PLUG_URL.'qc_images/trans.png);cursor:pointer;overflow:visible;" onmouseover="this.style.backgroundColor=\'#aaeaaa\'" '
				. 'onmouseout="this.style.backgroundColor=\'\'">
					<div style="padding:10px;display:inline-block;text-align:left;height:30px;width:350px;overflow:hidden;font-size:30px;" onclick="window.location=\'admin.php?page=qhistory&id='.$c['id'].'\'; cover_me();">'
					. truncate($c['name'],20).' <span class="orange">('.$messages.')</span></div>
					<!-- <div style="display:inline-block;text-align:left;height:15px;width:110px;" onclick="window.location=\'admin.php?page=qhistory&id='.$c['id'].'\'">'.$messages.' messages</div> -->
					<!-- <div style="display:inline-block;text-align:left;height:15px;width:75px;" onclick="window.location=\'admin.php?page=qhistory&id='.$c['id'].'\'">'.$c['time'].' sec.</div> -->
					<!-- <div style="display:inline-block;text-align:left;height:15px;width:150px;" onclick="window.location=\'admin.php?page=qhistory&id='.$c['id'].'\'">'.date("M j Y", $c['date']).'</div> -->
					<div onclick="window.location=\'admin.php?p=qhistory&id='.$c['id'].'\'" style="padding:4px;display:inline-block;text-align:left;height:30px;width:160px;" '
					. 'onclick="window.location=\'admin.php?page=qhistory&id='.$c['id'].'\'">'.timetostr(time() - $c['date']).'</div>
					<div style="padding:4px;display:inline-block;text-align:left;height:30px;width:25px;font-size:24px;" onmouseover="this.style.color=\'#ea0000\'" onmouseout="this.style.color=\'#ffffff\'" '
					. 'onclick="delete_session('.$c['id'].', \''.$c['name'].'\', '.$messages.');"><b>x</b></div>
				</div>
				<div style="height:5px;"></div>';
			}
			if ($i)
			{
				// PAGING STUFF =====------------
				$num_pages = ceil(mysql_num_rows(mysql_query("SELECT * FROM `qchat_sessions`"))/10);
				
				$page_prev = $page-1;
				if ($page_prev < 1) $page_prev = $num_pages;
				
				$page_next = $page+1;
				if ($page_next > $num_pages) $page_next = 1;
				
				echo '<b>'.$page.'</b> / '.$num_pages.'<br/>
				<a href="admin.php?page=qhistory&page_no='.$page_prev.'" onclick="cover_me()"><img src="'.PLUG_URL.'qc_images/btn_previous.png" border="0" /></a>
				&nbsp;
				<a href="admin.php?page=qhistory&page_no='.$page_next.'" onclick="cover_me()"><img src="'.PLUG_URL.'qc_images/btn_next.png" border="0" /></a>';
				
				
				// DELETE BUTTON
				echo '<br/><br/><br/><br/><a href="#" onclick="delete_all()"><img src="'.PLUG_URL.'qc_images/btn_deleteall.png" border="0" /></a>';
			}
			else echo '<center>no message history</center>';
			
			echo '</div>'; // CLOSE AJAX DIV
		}
						
		echo $this->qchat_footer();
	}
	
	function qchat_homepage()
	{
		global $setting;
		if (isset($_GET['act']) && $_GET['act'] == "change_status")
		{
			if ($setting['online']) $v='0';
			else $v='1';
			mysql_query("UPDATE `qchat_settings` SET `online`='".$v."'") or die (mysql_error());
			$setting['online'] = $v;
		}
		echo $this->qchat_header();
		?>
    <a href="?page=qonline"><img border="0" src="<?php echo PLUG_URL; ?>qc_images/btn_online.png" class="main_btn" onclick="cover_me()" /></a> <a href="?page=qhistory"><img border="0" src="<?php echo PLUG_URL; ?>qc_images/btn_history.png" class="main_btn" onclick="cover_me()" /></a> <a href="?page=qsettings"><img border="0" src="<?php echo PLUG_URL; ?>qc_images/btn_settings.png" class="main_btn" onclick="cover_me()" /></a> <br />
    <table width="475" border="0" cellspacing="0" cellpadding="0">
      <tr>
        <td align="left" valign="middle"><img src="<?php echo PLUG_URL; ?>qc_images/qc_status.png" width="265" height="34" /></td>
        <td align="right" valign="middle"><a href="admin.php?page=qchat&act=change_status">
          <?php
          if ($setting['online'])
          echo '<img src="'.PLUG_URL.'qc_images/qc_status_online.png" border="0" width="158" height="53" onclick="cover_me()" />';
          else
          echo '<img src="'.PLUG_URL.'qc_images/qc_status_offline.png" border="0" width="158" height="53" onclick="cover_me()" />';
          ?>
          </a></td>
      </tr>
    </table>
    <br />
    <div style="border: 1px solid #333; border-collapse: collapse; background-color: #EFEFEF;">
    <h2>HELP! How Do I Insert A Chat Button?</h2>
    <p align="justify" style="width: 450px; margin:0 auto;">Adding the chat button to your site is very simple. In either page or post place one<br />of the two short-codes below where you want a chat button to appear. Thats it.</p>
    <p>For an <strong>Inline Floating Chat Window</strong>: <input type="text" style="width: 150px; text-align:center; border: 1px solid #333; padding: 5px; cursor:pointer;" onfocus="this.select();" value="[qc_chat_button]" /> ( <a href="<?php echo PLUG_URL; ?>qc_example_floating.html" target="_blank">Preview</a> )</p>
    <p>For a <strong>Popup Chat Window</strong>: <input type="text" style="width: 150px; text-align:center; border: 1px solid #333; padding: 5px; cursor:pointer;" onfocus="this.select();" value="[qc_chat_button_inline]" /> ( <a href="<?php echo PLUG_URL; ?>qc_example_popup.html" target="_blank">Preview</a> )</p>
    </div>
    
    <?php
		echo $this->qchat_footer();
	}
	
	function qchat_settings()
	{
		global $setting, $carriers;
		
		$text = $email = $none = NULL;
		
		if (isset($_POST['act']) && $_POST['act'] == "update_settings")
		{
			if ($_POST['notify'] == "text") $notify_to = $_POST['number'].$_POST['carrier'];
			elseif ($_POST['notify'] == "email") $notify_to = $_POST['email'];
			
			if ($_POST['offline_notify'] == "text") $offline_notify_to = $_POST['offline_number'].$_POST['offline_carrier'];
			elseif ($_POST['offline_notify'] == "email") $offline_notify_to = $_POST['offline_email'];
			mysql_query("UPDATE `qchat_settings` SET `name`='".$_POST['name']."', `greeting_online`='".mysql_real_escape_string($_POST['greeting_online'])."',
			`greeting_offline`='".mysql_real_escape_string($_POST['greeting_offline'])."', `notify`='".$_POST['notify']."', `notify_to`='".$notify_to."',
			`notify_from`='".$_POST['notify_from']."', `offline_notify`='".$_POST['offline_notify']."', `offline_notify_to`='".$offline_notify_to."',
			`offline_mode`='".$_POST['offline_mode']."', `offline_message_fields`='".mysql_real_escape_string($_POST['offline_message_fields'])."' ") or die (mysql_error());
			$setting = @mysql_fetch_assoc(mysql_query("SELECT * FROM `qchat_settings` LIMIT 1"));
		}
		
		echo $this->qchat_header();
    ?>
    <table align="center" width="95%" border="0" cellpadding="0" cellspacing="0"><tr><td align="left"><a href="admin.php?page=qchat"><img src="<?php echo PLUG_URL; ?>qc_images/btn_back.png" border="0"></a></td>
    <td align="right"><h2>Quack Chat Settings</h2></td></tr></table>
    <form method="POST">
      <span class="orange">General Chat Settings</span>
      <table align="center" width="95%" border="0" cellspacing="0" cellpadding="5" style="font-size:18px;">
        <tr>
          <td align="left" width="150">Operator's Name:</td>
          <td align="left"><input type="text" name="name" value="<?php echo $setting['name']; ?>" style="width:100%;" /></td>
        </tr>
        <tr>
          <td align="left">Online Greeting:</td>
          <td align="left"><textarea name="greeting_online" style="width:100%;height:50px;"><?php echo $setting['greeting_online']; ?></textarea></td>
        </tr>
        <tr>
          <td align="left">Offline Greeting:</td>
          <td align="left"><textarea name="greeting_offline" style="width:100%;height:50px;"><?php echo $setting['greeting_offline']; ?></textarea></td>
        </tr>
      </table>
      <br />
      <span class="orange">Notification Settings</span>
      <table align="center" width="95%" border="0" cellspacing="0" cellpadding="5" style="font-size:18px;">
        <tr>
          <td width="150" align="left">Send alerts from:</td>
          <td align="left"><input type="text" name="notify_from" value="<?php echo $setting['notify_from']; ?>" placeholder="email@example.com" style="width:100%;" /></td>
        </tr>
        <tr>
          <td align="left" width="150">Alert me via:</td>
          <td align="left"><select name="notify" id="notify" onchange="set_alert(this.value);">
              <option value="text" <?php echo (($setting['notify']=='text')?' selected="selected"':NULL); ?>>Text Message</option>
              <option value="email" <?php echo (($setting['notify']=='email')?' selected="selected"':NULL); ?>>E-mail</option>
              <option value="none" <?php echo (($setting['notify']=='none')?' selected="selected"':NULL); ?>>Do not alert me... ever!</option>
            </select></td>
        </tr>
        <tr>
          <td align="left">Send alerts to:</td>
          <td align="left"><div id="alerts_text" <?php echo ($setting['notify']=="text")?'':'style="display:none"'; ?>>
              <input type="text" name="number" size="10" placeholder="your number" value="<?php echo preg_replace("/^(.+?)@.+$/", "$1", $setting['notify_to']); ?>" />
              @
              <select name="carrier" id="carrier">
                <?php
                  if ($setting['notify']=="text") $carrier = preg_replace("/^.+?@(.+)$/", "$1", $setting['notify_to']); else $carrier = NULL;
                  
                  foreach ($carriers as $cname => $caddr)
                  {
                    if ($carrier == $caddr)
                      echo '<option value="@'.$caddr.'" selected="selected">'.$cname.'</option>';
                    else
                      echo '<option value="@'.$caddr.'">'.$cname.'</option>';
                  }
                  ?>
              </select>
            </div>
            <div id="alerts_email" <?php echo ($setting['notify']=="email")?'':'style="display:none"'; ?>>
              <input type="text" name="email" value="<?php echo $setting['notify_to']; ?>" placeholder="email@example.com" style="width:100%">
            </div>
            <div id="alerts_none" <?php echo ($setting['notify']=="none")?'':'style="display:none"'; ?>>I will not notify you... ever!</div></td>
        </tr>
      </table>
      <br />
      <span class="orange">Offline Notifications</span>
      <table align="center" width="95%" border="0" cellspacing="0" cellpadding="5" style="font-size:18px;">
        <tr>
          <td align="left" width="150">Alert me via:</td>
          <td align="left"><select name="offline_notify" id="offline_notify" onchange="set_offline_alert(this.value);">
              <option value="text" <?php echo (($setting['offline_notify']=='text')?' selected="selected"':NULL); ?>>Text Message</option>
              <option value="email" <?php echo (($setting['offline_notify']=='email')?' selected="selected"':NULL); ?>>E-mail</option>
              <option value="none" <?php echo (($setting['offline_notify']=='none')?' selected="selected"':NULL); ?>>Quiet Time...</option>
            </select></td>
        </tr>
        <tr>
          <td align="left">Send alerts to:</td>
          <td align="left"><div id="offline_alerts_text" <?php echo ($setting['offline_notify']=="text")?'':'style="display:none"'; ?>>
              <input type="text" name="offline_number" size="10" placeholder="your number" value="<?php echo preg_replace("/^(.+?)@.+$/", "$1", $setting['offline_notify_to']); ?>" />
              @
              <select name="offline_carrier" id="offline_carrier">
                <?php
                  if ($setting['offline_notify']=="text") $carrier = preg_replace("/^.+?@(.+)$/", "$1", $setting['offline_notify_to']);  else $carrier = NULL;
                  
                  foreach ($carriers as $cname => $caddr)
                  {
                    if ($carrier == $caddr)
                      echo '<option value="@'.$caddr.'" selected>'.$cname.'</option>';
                    else
                      echo '<option value="@'.$caddr.'">'.$cname.'</option>';
                  }
                  ?>
              </select>
            </div>
            <div id="offline_alerts_email" <?php echo ($setting['offline_notify']=="email")?'':'style="display:none"'; ?>>
              <input type="text" name="offline_email" value="<?php echo $setting['offline_notify_to']; ?>" placeholder="email@example.com" style="width:100%">
            </div>
            <div id="offline_alerts_none" <?php echo ($setting['offline_notify']=="none"||!$setting['offline_notify'])?'':'style="display:none"'; ?>>Quiet Time...</div></td>
        </tr>
      </table>
      <div id="offline_mode_setting" <?php echo ($setting['offline_notify']!='none')?'':'style="display:none;"'; ?>>
        <table align="center" width="95%" border="0" cellspacing="0" cellpadding="5" style="font-size:18px;">
          <tr>
            <td align="left" width="150">Mode:</td>
            <td align="left"><select name="offline_mode" onchange="set_offline_mode(this.value);">
                <option value="first_response" <?php echo (($setting['offline_mode']=='first_response')?' selected="selected"':NULL); ?>>First Response</option>
                <option value="leave_message" <?php echo (($setting['offline_mode']=='leave_message')?' selected="selected"':NULL); ?>>Leave A Message</option>
              </select></td>
          </tr>
          <tr id="offline_mode_fields" <?php echo ($setting['offline_mode']!='leave_message')?'style="display:none;"':''; ?>>
            <td align="left" width="150" valign="top">Fields:</td>
            <td align="left"><textarea name="offline_message_fields" style="height:75px;width:75%;"><?php echo ($setting['offline_message_fields'])?$setting['offline_message_fields']:"Name
E-mail
Reason for contact"; ?></textarea></td>
          </tr>
        </table>
      </div>
      <br />
      <input type="hidden" name="act" value="update_settings" />
      <input type="submit" value="  UPDATE SETTINGS!  " style="border:1px solid #09182f;border-radius:10px;background-color:#2f5a87;color:#ffffff;padding:10px;" />
      <img src="<?php echo PLUG_URL; ?>qc_images/trans.png">
    </form>
    <?php
		echo $this->qchat_footer();
	}

}
?>
