<?php
class qc_public {

	function __construct()
	{
		// Set up Actions
		add_action( 'init', array(&$this, 'initialise_plugin'), 1 );
		add_action( 'generate_rewrite_rules', array(&$this, 'add_rewrites') );
	}


	function initialise_plugin()
	{
		add_shortcode('qc_chat_button', array(&$this, 'do_chat_button') );
		add_shortcode('qc_chat_button_inline', array(&$this, 'do_chat_button_inline') );
		add_filter('the_posts', array(&$this, 'add_scripts'));
	}

	function add_rewrites($wp_rewrite)
	{
		$new_rules = array();
		$new_rules['^qcchat\.php(.*?)$'] = '/wp-content/plugins/quack-chat/qcchat.php' . $wp_rewrite->preg_index(1);
		$new_rules = apply_filters('M_rewrite_rules', $new_rules);
	  $wp_rewrite->rules = array_merge($new_rules, $wp_rewrite->rules);
		return $wp_rewrite;
	}
	
	function do_chat_button($atts, $content = null, $code = "")
	{
		global $wp_query;
		$error = array();
		$page = addslashes($_REQUEST['action']);
		$click = "window.open('".PLUG_URL."qchat.php','QuackChat','status=no,resizable=no,width=450,height=440')";
		$content = '<img src="'.PLUG_URL.'qc_status.php" alt="Chat Now" width="198" height="64" onclick="'.$click.'" style="cursor:pointer;" />';
		return $content;
	}
	
	function do_chat_button_inline($atts, $content = null, $code = "")
	{
		global $wp_query;
		$error = array();
		$page = addslashes($_REQUEST['action']);
		
		$content = '<a href="javascript:void(0);" onclick="qc_inline.create();" title="Need Help? Chat Now"><img src="'.PLUG_URL.'qc_status.php" border="0" alt="Start Chat" /></a>'
		. '<script language="javascript">'
		. 'var PLUG_URL = "'.PLUG_URL.'"; '
		. 'qc_inline.initialize();'
		. '</script>';
		return $content;
	}
		
	function add_scripts($posts)
	{
		foreach($posts as $key => $post)
		{
			if(strstr($post->post_content, '[qc_chat_button]') !== false)
			{
			}
			
			if(strstr($post->post_content, '[qc_chat_button_inline]') !== false)
			{
				wp_enqueue_style('qc_inline_css', PLUG_URL.'qc_bin/qc_inline.css');
        wp_enqueue_script('qc_inline_js', PLUG_URL.'qc_bin/qc_inline.js');
			}
		}

		return $posts;
	}
}
?>