<?php
// GLOBAL ARRAYS ==================================================================================
$carriers['Alltel'] = 'message.alltel.com';
$carriers['AT&T'] = 'txt.att.net';
$carriers['Boost'] = 'myboostmobile.com';
$carriers['Cingular'] = 'mobile.mycingular.com';
$carriers['Nextel'] = 'messaging.nextel.com';
$carriers['Sprint'] = 'messaging.sprintpcs.com';
$carriers['T-Mobile USA'] = 'tmomail.net';
$carriers['Verizon Wireless'] = 'vtext.com';
$carriers['Virgin Mobile USA'] = 'vmobl.com';


// GLOBAL FUNCTIONS ===============================================================================
function truncate($string, $maxlen)
{
  if (strlen($string) > $maxlen):
    $tmpstr = $string;
    $string = $tmpstr{0};
    for ($i = 1; $i <= $maxlen-3; $i++):
      $string .= $tmpstr{$i};
    endfor;
    $string .= "...";
    return $string;
  else:
    return $string;
  endif;
}

function realip()
{
   if (isSet($_SERVER)) {
     if (isSet($_SERVER["HTTP_X_FORWARDED_FOR"])) {
     $realip = $_SERVER["HTTP_X_FORWARDED_FOR"];
     } elseif (isSet($_SERVER["HTTP_CLIENT_IP"])) {
     $realip = $_SERVER["HTTP_CLIENT_IP"];
     } else {
     $realip = $_SERVER["REMOTE_ADDR"];
     }
   } else {
     if ( getenv( 'HTTP_X_FORWARDED_FOR' ) ) {
     $realip = getenv( 'HTTP_X_FORWARDED_FOR' );
     } elseif ( getenv( 'HTTP_CLIENT_IP' ) ) {
     $realip = getenv( 'HTTP_CLIENT_IP' );
     } else {
     $realip = getenv( 'REMOTE_ADDR' );
     }
   }
   
   return $realip;
}

function timetostr($time)
{
  if ($time < 60)
    $time = $time.' sec.';
  elseif ($time < 3600)
  {
    $min = floor($time/60);
    $sec = $time - ($min*60);
    if ($sec < 10) $sec = '0'.$sec;
    $time = $min.' min';
  }
  elseif ($time < 86400)
  {
    $hr = floor($time/3600);
    $min = floor(($time - ($hr*3600)) / 60);
    $sec = $time - (($min*60)+($hr*3600));
    if ($sec < 10) $sec = '0'.$sec;
    $time = $hr.' hr.';
  }
  else
  {
    $day = floor($time/86400);
    $hr = floor(($time/3600) - ($day * 24));
    $min = floor(($time - ($hr*3600) - ($day*86400)) / 60);
    $sec = $time - (($min*60)+($hr*3600)+($day*86400));
    if ($sec < 10) $sec = '0'.$sec;
    if ($day == 1) $time = 'Yesterday';
    else $time = $day.' days';
  }
	if ($time != 'Yesterday') $time = $time . ' ago';
  return $time;
}

function null_tags ($html)
{
  $html = preg_replace("/<(.+?)>/i", "<font color=\"red\">&lt;$1&gt;</font>", $html);
  return $html;
}
?>