/* QUACK CHAT DYNAMICS FILE

Written By: Aaron Mihalchan

Copyright 2012 Endat / Aaron @ Code Canyon
*/
var qc_chat = {
  base_url: '../',
  resolution: screen.width+"x"+screen.height,
  time_onpage: 0,
  message_ping: 0,
  c_session: 0,
  page: '',
  user_info: {'c_name':'', 'load_history':'0', 'id':'0'},
  switching_session:false,
	
	ios: false,
	muted: false,
	canHTML5:{'mp3':null, 'wav':null, 'ogg':null},
	checkHTML5: function(type)
	{
		var a = document.createElement('audio'); 
		if (type == 'wav') return !!a.canPlayType;
		if (type == 'mp3') return !!(a.canPlayType && a.canPlayType('audio/mpeg;').replace(/no/, ''));
		if (type == 'ogg') return !!(a.canPlayType && a.canPlayType('audio/ogg;').replace(/no/, ''));
	},
	
	ios_enabled: function()
	{
		this.muted = false;
		var sound = document.getElementsByTagName("audio")[0];
		//sound.style.opacity = "0";
		document.getElementById('ios_sound_enabled').style.display = 'block';
		
	},
	
  setup: function(page, user_info)
  {
		this.ios = ((navigator.userAgent.match(/iPhone/i)) || (navigator.userAgent.match(/iPod/i)) || (navigator.userAgent.match(/iPad/i))) ? true:false;
		if (this.ios) this.muted = true;
		
		this.canHTML5.mp3 = this.checkHTML5('mp3');
		this.canHTML5.ogg = this.checkHTML5('ogg');
		this.canHTML5.wav = this.checkHTML5('wav');
    this.page = page;
		
    switch(page)
    {
      case "not_implemented":
        this.get_current_traffic();
      break;
      case "qonline":
        this.get_chat_sessions();
        this.counter_count();
      break;
      case "user":
        this.base_url = '';
        this.user_info = user_info;
				
        this.update_chat();
				if (this.user_info.load_history==1)
				{
					this.fetch_chat_history();
					this.c_session = this.user_info.id;
				}
        this.counter_count();
      break;
      default:break;
    }
  },
  
  counter_count: function()
  {
    this.time_onpage++;
    var self = this;
    setTimeout(function(){ self.counter_count(); }, 1000);
  },
  
  // ONLINE
  get_current_traffic_http:false,
  get_current_traffic: function()
  {
    var url = this.base_url+"qc_bin/get_current.php";
    
    if (this.get_current_traffic_http===false)this.get_current_traffic_http=ajax_init();
    var MessageRequest = this.get_current_traffic_http;//ajax_init();
    
    if(MessageRequest) {
      MessageRequest.open("GET", url);
      MessageRequest.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
      var self = this;
      MessageRequest.onreadystatechange = function()
      {
        if (MessageRequest.readyState == 4 && MessageRequest.status == 200) {
          document.getElementById('current_traffic').innerHTML = MessageRequest.responseText;
          setTimeout(function(){ self.get_current_traffic(); }, 3000);
        }
      }
      MessageRequest.send();
    }
  },
  
  insert_message: function(message)
  {
    var div = document.createElement('div');
    div.innerHTML = message;
    document.getElementById('chat_window').appendChild(div);
    document.getElementById('chat_window').scrollTop = document.getElementById('chat_window').scrollHeight;
  },
  
  clear_messages: function()
  {
    document.getElementById('chat_window').innerHTML = '';
  },
  
  fetch_chat_history_http:false,
  fetch_chat_history: function()
  {
    var url = this.base_url+"qc_bin/get_session.php";
    
    if (this.page == 'user')
    url = this.base_url+"qc_bin/chat_session.php";
    
    if (this.fetch_chat_history_http===false)this.fetch_chat_history_http=ajax_init();
    var XMLHttpRequestObject = this.fetch_chat_history_http;//ajax_init();
    
    if(XMLHttpRequestObject) {
      XMLHttpRequestObject.open("POST", url);
      XMLHttpRequestObject.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
      var self = this;
      XMLHttpRequestObject.onreadystatechange = function()
      {
        if (XMLHttpRequestObject.readyState == 4 && XMLHttpRequestObject.status == 200) {
          //alert(XMLHttpRequestObject.responseText);
          
          var x = eval('(' + XMLHttpRequestObject.responseText + ')');
          
          // add history
          if (x.messages.count > 0)
          {
						
            for (var i=0; i<x.messages.count; i++)
            {
              self.insert_message(x.messages[i].message);
            }
						if (self.user_info.load_history == 1)
						self.insert_message('Welcome back! Your session is still active.');
          }
        }
      }
      
      if (this.page == 'user')
      XMLHttpRequestObject.send("get_history=1&name="+this.user_info.c_name+"&resolution="+this.resolution+"&time="+this.time_onpage);
      else 
      XMLHttpRequestObject.send("get_history=1&a=1&s="+this.c_session+"&resolution="+this.resolution+"&time="+this.time_onpage);
    }
  },
  
  update_chat_http:false,
  update_chat: function()
  {
    // if they switch a session stop all updates
    if (this.switching_session)
    {
      setTimeout(function(){ self.update_chat(); }, 2000);
      return;
    }
    
    var url = this.base_url+"qc_bin/get_session.php";
    
    if (this.page == 'user')
    url = this.base_url+"qc_bin/chat_session.php";

    if (this.update_chat_http===false)this.update_chat_http=ajax_init();
    var XMLHttpRequestObject = this.update_chat_http;//ajax_init();
    
    if(XMLHttpRequestObject) {
      XMLHttpRequestObject.open("POST", url);
      XMLHttpRequestObject.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
      var self = this;
      XMLHttpRequestObject.onreadystatechange = function()
      {
        if (XMLHttpRequestObject.readyState == 4 && XMLHttpRequestObject.status == 200) {
          //alert(XMLHttpRequestObject.responseText);
          self.message_ping++;
          
          var x = eval('(' + XMLHttpRequestObject.responseText + ')');
          
          if (x.action == 'no_sessions')
          {
            document.getElementById('current_ph').style.display = '';
            document.getElementById('current_chat').style.display = 'none';
            document.getElementById('chat_window').innerHTML = '<br><br><center>Loading...</center>';
          }
          else
          {
            if (x.action == 'register' && self.page == 'user')
            {
              /// IF THIS IS THE FIRST RESPONSE, /bin/chat_session.php HAS SENT US A SESSION ID (line 34 of /qc_bin/chat_session.php)
              self.c_session = x.c_id;
            } else {
              self.message_ping++;
              document.getElementById('message_window').style.display = '';
              document.getElementById('message_holder').style.display = 'none';
                    
              // This if statement is called when you switch a session or if you initiate a chat first time
              if (typeof self.session_history['s'+self.c_session] != 'undefined' && self.session_history['s'+self.c_session] === false)
              {
                // Clear history, start fresh.
                self.clear_messages();
                
                // Send default welcome messages
                if (x.action == 'admin')
                {
                  var str = '<table width="100%" border="0" cellpadding="2" cellspacing="0">'
                    + '<tr>'
                      + '<td><font color="#ffc900">Chatting with <b>'+x.name+'</b></font></td>'
                      + '<td align="right">'+x.activity+'</td>'
                    + '</tr>'
                  + '</table>'
                  + '<hr style="border:1px dotted #aeaeae;">';
                  self.insert_message(str);
                }
                else
                {
                  self.insert_message("<font color=\"#aeaeae\">You are now chatting with one of our administrators.</font><hr style=\"border:1px dotted #aeaeae;\" style=\"background-image:url('http://wwww.quack-chat.com/images/element.png');\">");
                }
                // history has been initialized, no need to come back here.
                self.session_history['s'+self.c_session] = true;
                // get the message history, switching sessions or closing the window and coming back is what this was made for
                self.fetch_chat_history();
              }
              // chat has already been initialized. just grab any new messages
              else
              {
                if (x.messages.count > 0)
                {
                  for (var i=0; i<x.messages.count; i++)
                  {
                    self.insert_message(x.messages[i].message);
                  }
                }
              }
              
              if (x.sound==1)
              {
                self.play_sound('s3');
              }
              
              // set focus inside the chat 
              self.focus_chat();
            }
  
            if (self.time_onpage == 0) {self.time_onpage=1;}
            
            setTimeout(function(){ self.update_chat(); }, 1500);
          }
        }
      }
      
      if (this.page == 'user')
			XMLHttpRequestObject.send("name="+this.user_info.c_name+"&resolution="+this.resolution+"&time="+this.time_onpage+"&existing_session="+this.user_info.load_history);
      else 
      XMLHttpRequestObject.send("a=1&s="+this.c_session+"&resolution="+this.resolution+"&time="+this.time_onpage);
    }
  },
  
  send_message_http:false,
  send_message: function()
  {
    document.getElementById('message_window').style.display = 'none';
    document.getElementById('message_holder').style.display = '';
    document.getElementById('message_holder').innerHTML = "<br><br>Your message is being sent.";
    
    var url = this.base_url+"qc_bin/send_message.php";
    var message = document.getElementById('chat_message').value;
    
    if (this.send_message_http===false)this.send_message_http=ajax_init();
    var MessageRequest = this.send_message_http;//ajax_init();
    
    if(MessageRequest)
    {
      MessageRequest.open("POST", url);
      MessageRequest.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
      var self = this;
      MessageRequest.onreadystatechange = function()
      {
        if (MessageRequest.readyState == 4 && MessageRequest.status == 200) {
          //self.update_chat();
          document.getElementById('chat_message').value = '';
          document.getElementById('message_window').style.display = '';
          document.getElementById('message_holder').style.display = 'none';
        }
      }
      
      if (this.page == 'user')
      MessageRequest.send("session="+this.c_session+"&message="+message);
      else
      {
        //alert(''+this.page);
        MessageRequest.send("a=1&s="+this.c_session+"&message="+message);
      }
    }
  },
  
  // GET AVAILABLE USER LIST
  get_chat_sessions_http:false,
  get_chat_sessions: function()
  {
		var self = this;
    var url = this.base_url+"qc_bin/get_chat.php";
    if (this.get_chat_sessions_http===false)this.get_chat_sessions_http=ajax_init();
    var ChatSessionsRequest = this.get_chat_sessions_http;//ajax_init();
    if(ChatSessionsRequest) {
      ChatSessionsRequest.open("POST", url);
      ChatSessionsRequest.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
      var self = this;
      ChatSessionsRequest.onreadystatechange = function()
      {
        if (ChatSessionsRequest.readyState == 4 && ChatSessionsRequest.status == 200) {
          //alert(ChatSessionsRequest.responseText);
					var x = eval('(' + ChatSessionsRequest.responseText + ')');
          document.getElementById('chat_sessions').innerHTML = x.html;//ChatSessionsRequest.responseText;
          if (x.plays.s1) self.play_sound('s1');
					if (x.plays.s2) self.play_sound('s2');
					if (x.plays.s3) self.play_sound('s3');
					if (x.plays.s4) self.play_sound('s4');
          setTimeout(function(){ self.get_chat_sessions(); }, 3000);
        }
      }
      ChatSessionsRequest.send('session='+this.c_session);
    }
  },

  session_history: {},

  switch_session: function(id)
  {
    if (this.c_session == id) return;
    this.switching_session = true;
    this.session_history['s'+id] = false;

    this.c_session = id;
    document.getElementById('current_ph').style.display = 'none';
    document.getElementById('current_chat').style.display = '';
    document.getElementById('chat_window').innerHTML = '<br><br><center>Loading...</center>';
    this.get_chat_sessions();
    this.switching_session = false;
    this.update_chat();
  },
  
  focus_chat: function()
  {
    document.getElementById('chat_message').focus();
  },
  
  ifEnter: function(field, event)
  {
    var theCode = event.keyCode ? event.keyCode : event.which ? event.which : event.charCode;
    
    //alert(theCode);
    if (theCode == 13 || theCode == 10) {
      this.send_message();
      return true;
    } else
      return true;
  },
  
	snd:{},
  play_sound: function(sb)
  {
		if (this.muted) return;
		
		switch(sb)
		{
			case "s1": var file = "scifi014"; break;
			case "s2": var file = "cartoon054"; break;
			case "s3": var file = "water1"; break;
			case "s4": var file = "nautical007"; break;
		}
		if (this.canHTML5.mp3 || this.canHTML5.ogg || this.canHTML5.wav)
		{
			var format = ((this.canHTML5.ogg)?'ogg':((this.canHTML5.mp3)?'mp3':'wav'));
			//format = "ogg";
			//alert(this.base_url+"qc_bin/sounds/"+file+"."+format);
			
			if (this.ios)
			{
				var sound = document.getElementsByTagName("audio")[0];
				sound.play();
			}
			else
			{
			if (this.snd[file] == null) this.snd[file] = new Audio(this.base_url+"qc_bin/sounds/"+file+"."+format); // buffers automatically when created
			this.snd[file].play();
		}
		}
		else
		{
			var format = "mp3";
			document.getElementById('sound_bite').innerHTML = '<object classid="clsid:D27CDB6E-AE6D-11cf-96B8-444553540000" codebase="http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=9,0,28,0" width="1" height="1"><param name="movie" value="http://www.staticplayer.com/Flash/chameleon.swf" /><param name="AllowScriptAccess" value="always" /><param name="quality" value="high" /><param name="scale" value="noscale" /><param name="salign" value="lt" /><param name="wmode" value="transparent" /><param name="flashvars" value="mp3_url=./qc_bin/sounds/'+file+"."+format+'&autoplay=yes&bg_type=none&bg_width=1&bg_height=1" /><embed src="http://www.staticplayer.com/Flash/chameleon.swf" allowscriptaccess="always" quality="high" scale="noscale" salign="lt" wmode="transparent" flashvars="mp3_url=./qc_bin/sounds/'+file+"."+format+'&autoplay=yes&bg_type=none&bg_width=1&bg_height=1" pluginspage="http://www.adobe.com/shockwave/download/download.cgi?P1_Prod_Version=ShockwaveFlash" type="application/x-shockwave-flash" width="2" height="2"></embed></object>';
		}
  }
};