/* QUACK CHAT INLINE WINDOW FILE

Written By: Aaron Mihalchan

Copyright 2012 Endat / Aaron @ Code Canyon
*/
var qc_inline = {
	
	init: null,
	setup: null,
	mouseOffset: null,
	
	initialize: function()
	{
		if (this.init===true) return false;
		this.init = true;
		var self = this;
		
		// Create event listener for moving mouser
		window.onmousemove = function(ev){ self.moveit(ev); };
		
		// Do we need to auto load?
		var auto_load = self.getCookie("qc_auto_load");
		if (auto_load != null && auto_load != "")
		{
			this.create();
		}
	},

	create: function()
	{
		// already setup? then dont continue;
		if (this.setup===true) return false;
		this.setup = true;
		
		// did the initialization go through?
		// its needed for auto loading windows and 
		// setting up event listeners
		if (this.init === false) this.initialize();
		
		if (typeof PLUG_URL == 'undefined') PLUG_URL = '';
		var self = this;
		self.setCookie("qc_auto_load", "yes", 1);
		
		// make container which is moved / resized. Everything goes in here.
		var qc_chat = document.createElement("DIV");
		qc_chat.setAttribute("id", "qc_chat");
		qc_chat.setAttribute("class", "qc_chat");
		
		// create the handle which allows the positioning of the container
		var qc_chat_handle = document.createElement("DIV");
		qc_chat_handle.setAttribute("id", "qc_chat_handle");
		qc_chat_handle.setAttribute("class", "qc_chat_handle");
		qc_chat_handle.onmousedown = function(ev)
		{
			self.mouseOffset = self.getMouseOffset(document.getElementById('qc_chat'), ev);
			return false;
		}
		qc_chat_handle.onmouseup = function(ev)
		{
			var coords = parseInt(document.getElementById('qc_chat').style.top)+'|'+parseInt(document.getElementById('qc_chat').style.left);
			self.setCookie("qc_chat_coords", coords, 30);
			self.mouseOffset = null;
			return false;
		}
		
		// create the close chat window button
		var qc_chat_handle_exit = document.createElement("DIV");
		qc_chat_handle_exit.setAttribute("id", "qc_chat_handle_exit");
		qc_chat_handle_exit.setAttribute("class", "qc_chat_handle_exit");
		qc_chat_handle_exit.onclick = function()
		{
			if (confirm("Really close the chat window?"))
			{
				self.setup = false;
				self.setCookie("qc_auto_load", "", 1);
				document.getElementsByTagName("BODY")[0].removeChild(document.getElementById('qc_chat'));
			}
		}
		
		// this is the internal container used for relatively positioning its children
		var qc_chat_con = document.createElement("DIV");
		qc_chat_con.setAttribute("id", "qc_chat_con");
		qc_chat_con.setAttribute("class", "qc_chat_con");
		
		// this iframe will connect to qchat.php. 
		var qc_chat_iframe = document.createElement("IFRAME");
		qc_chat_iframe.setAttribute("id", "qc_chat_iframe");
		qc_chat_iframe.setAttribute("class", "qc_chat_iframe");
		qc_chat_iframe.setAttribute("scrolling", "no");
		qc_chat_iframe.setAttribute("frameborder", "0");
		qc_chat_iframe.setAttribute("allowtransparency", "0");
		qc_chat_iframe.setAttribute("src", PLUG_URL+"qchat.php");

		// create them
		qc_chat_handle.appendChild(qc_chat_handle_exit);
		qc_chat_con.appendChild(qc_chat_handle);
		qc_chat.appendChild(qc_chat_con);
		qc_chat.appendChild(qc_chat_iframe);
		document.getElementsByTagName("BODY")[0].appendChild(qc_chat);
		
		// Center the chat window.
		var coords = self.getCookie("qc_chat_coords");
		if (coords != null && coords != "")
		{
			var d = coords.split("|");
			var size = this.windowSizeCoords();
			// in case the size of the page is different we need to reposition it.
			if (size.h < d[0]) this.centerWindow(document.getElementById('qc_chat'));	
			else
			{
				document.getElementById('qc_chat').style.top = d[0]+'px';
				document.getElementById('qc_chat').style.left = d[1]+'px';
			}
		}
		else this.centerWindow(document.getElementById('qc_chat'));	
		
	},
	
	moveit: function(ev)
	{
		if (this.mouseOffset == null) return;
		ev           = ev || window.event;
		var mousePos = this.mouseCoords(ev);
			
		document.getElementById('qc_chat').style.top = Number(mousePos.y - this.mouseOffset.y)+'px';
		document.getElementById('qc_chat').style.left = Number(mousePos.x - this.mouseOffset.x)+'px';
		return false;
	},
		
	getMouseOffset: function(target, ev)
	{
		ev = ev || window.event;
		var docPos    = qc_inline.getPosition(target);
		var mousePos  = qc_inline.mouseCoords(ev);
		return {x:mousePos.x - docPos.x, y:mousePos.y - docPos.y};
	},
	
	getPosition: function(e)
	{
		var left = 0;
		var top  = 0;
		while (e.offsetParent)
		{
			left += e.offsetLeft;
			top  += e.offsetTop;
			e     = e.offsetParent;
		}
		left += e.offsetLeft;
		top  += e.offsetTop;
		return {x:left, y:top};
	},
	
	mouseCoords: function(ev)
	{
		if(ev.pageX || ev.pageY){
			return {x:ev.pageX, y:ev.pageY};
		}
		return {
			x:ev.clientX + document.body.scrollLeft - document.body.clientLeft,
			y:ev.clientY + document.body.scrollTop  - document.body.clientTop
		};
	},
	
	windowScrollCoords: function()
	{
		return {
			x: (window.pageXoffset)?window.pageXoffset: ( document.documentElement && document.documentElement.scrollLeft )? document.documentElement.scrollLeft : document.body.scrollLeft,
			y: (window.pageYoffset)?window.pageYoffset: ( document.documentElement && document.documentElement.scrollTop )? document.documentElement.scrollTop : document.body.scrollTop
		};
	},
	
	windowSizeCoords: function()
	{
		return { 
			w: (window.innerWidth)?window.innerWidth: ( document.documentElement && document.documentElement.clientWidth )? document.documentElement.clientWidth : document.body.clientWidth, 
		 	h: (window.innerHeight)?window.innerHeight: ( document.documentElement && document.documentElement.clientHeight )? document.documentElement.clientHeight : document.body.clientHeight
		};
	},
	
	centerWindow: function(qc_chat)
	{
		var Xwidth = qc_chat.offsetWidth||parseInt(qc_chat.style.width);
		var Yheight = qc_chat.offsetHeight||parseInt(qc_chat.style.height);
		var offset = this.windowScrollCoords();
		var size = this.windowSizeCoords();
		//var leftoffset = offset.x + (size.w - Xwidth) / 2;
		//var topoffset = offset.y + (size.h - Yheight) / 2;
		var leftoffset = (size.w - Xwidth) / 2;
		var topoffset = (size.h - Yheight) / 2;
		qc_chat.style.top = topoffset+'px';
		qc_chat.style.left = leftoffset+'px';
	},
	
	setCookie: function(c_name,value,exdays)
	{
		var exdate=new Date();
		exdate.setDate(exdate.getDate() + exdays);
		var c_value=escape(value) + ((exdays==null) ? "" : "; expires="+exdate.toUTCString());
		document.cookie=c_name + "=" + c_value;
	},
	
	getCookie: function(c_name)
	{
		var i,x,y,ARRcookies=document.cookie.split(";");
		for (i=0;i<ARRcookies.length;i++)
		{
			x=ARRcookies[i].substr(0,ARRcookies[i].indexOf("="));
			y=ARRcookies[i].substr(ARRcookies[i].indexOf("=")+1);
			x=x.replace(/^\s+|\s+$/g,"");
			if (x==c_name)
			{
				return unescape(y);
			}
		}
	}
}